//+------------------------------------------------------------------+
//|                                                    LWMASlope.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 30 Jan 2015, Jack1"

//Edited by shahrooz "sh.sadeghi.me@gmail.com"  
//Modified by Jack1  "https://twitter.com/Jack1Fx"   
                     
//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Green          //Up1   up trend 
#property indicator_color2 Lime           //Up2   up trend strong
#property indicator_color3 FireBrick      //Dn1   Dn trend
#property indicator_color4 Red            //Dn2   Dn trend strong
#property indicator_color5 DarkGray       //Mid1  range
#property indicator_color6 LightSlateGray //Mid2  range strong
//#property indicator_color7 EMPTY

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2  
#property indicator_width6 2   
//#property indicator_width7 0   

//---- input parameters
extern int LWMA_Period = 21;            
extern int LWMA_Method = 1;   //1 - ema, 3 - lwma, 0 - sma, 2 - smma.
extern int LWMA_Price  = 0;   //0 - close, 1 - open, 4 - median, 5 - typical, 6 - weighted
extern double Bull_Above =  0.99;  //strong up trend, only buy
extern double Bear_Below = -0.99;  //strong dn trend, only sell

extern int ATR_Period = 100;

extern bool show_1st_MTF   =true;
extern int select_1st_tf_to_show=60; //M60
extern string TimeFrame_1st = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int H_Pos_MTF       =1;
extern int V_Pos_MTF       =30;
extern int Font_Size_MTF   =10;
extern int Corner_MTF      =3;   //corner 3
color      Font_Color_MTF;

//---- input parameters
extern bool show_2nd_MTF   =true;
extern int select_2nd_tf_to_show=240; //H4
extern string OtherTimeFrame_2nd = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int H_Pos_MTF_2nd      =1;
extern int V_Pos_MTF_2nd      =45;
extern int Font_Size_MTF_2nd  =10;
extern int Corner_MTF_2nd     =3;
color      Font_Color_MTF_2nd;

extern bool show_3rd_MTF   =true;
extern int select_3rd_tf_to_show=1440; //D1
extern string OtherTimeFrame_3rd = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int H_Pos_MTF_3rd      =1;
extern int V_Pos_MTF_3rd      =60;
extern int Font_Size_MTF_3rd  =10;
extern int Corner_MTF_3rd     =3;
color      Font_Color_MTF_3rd;
 
//current time frame slope value
extern color Font_Color          = White;
extern int   H_Pos               = 1;
extern int   V_Pos               = 15;
extern int   Corner              = 3;
extern int   Font_Size           = 10;
//trade suggestion
extern int   H_Pos_text          = 1;
extern int   V_Pos_text          = 1;
extern int   Corner_Text         = 3;
extern int   Font_Size_text      = 10;

//---- indicator buffers
double Up1[];
double Up2[];

double Dn1[];
double Dn2[];

double Mid1[];
double Mid2[];

double Slope[]; 
color  Font_Color_M15;

//double TICK;
//bool AdditionalDigit;

int    OldBars=0;
string TimeFrameStr,TimeFrameStr2,TimeFrameStr3;

double vect[];
double vect_sma[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{              
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,Bull_Above);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,Bear_Below );
 
   IndicatorBuffers( 7 );
   IndicatorDigits( 5 );
   IndicatorShortName( "LWMASlope_jack1" );
      
   SetIndexBuffer( 0, Up1  );    SetIndexLabel( 0, NULL );       SetIndexStyle( 0, DRAW_HISTOGRAM );
   SetIndexBuffer( 1, Up2  );    SetIndexLabel( 1, NULL );       SetIndexStyle( 1, DRAW_HISTOGRAM );
   SetIndexBuffer( 2, Dn1  );    SetIndexLabel( 2, NULL );       SetIndexStyle( 2, DRAW_HISTOGRAM );
   SetIndexBuffer( 3, Dn2  );    SetIndexLabel( 3, NULL );       SetIndexStyle( 3, DRAW_HISTOGRAM );
   SetIndexBuffer( 4, Mid1 );    SetIndexLabel( 4, NULL );       SetIndexStyle( 4, DRAW_HISTOGRAM );
   SetIndexBuffer( 5, Mid2 );    SetIndexLabel( 5, NULL );       SetIndexStyle( 5, DRAW_HISTOGRAM );

   SetIndexBuffer( 6, Slope );   SetIndexLabel( 6, "LWMA Slope" );    SetIndexStyle( 6, DRAW_NONE );
      
   SetIndexEmptyValue( 0, 0.0 );
   SetIndexEmptyValue( 1, 0.0 );
   SetIndexEmptyValue( 2, 0.0 );
   SetIndexEmptyValue( 3, 0.0 );
   SetIndexEmptyValue( 4, 0.0 );
   SetIndexEmptyValue( 5, 0.0 );
   
   switch(select_1st_tf_to_show)
   {
      case 1 : TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current";
   }    
   
   switch(select_2nd_tf_to_show)
   {
      case 1 : TimeFrameStr2="M1"; break;
      case 5 : TimeFrameStr2="M5"; break;
      case 15 : TimeFrameStr2="M15"; break;
      case 30 : TimeFrameStr2="M30"; break;
      case 60 : TimeFrameStr2="H1"; break;
      case 240 : TimeFrameStr2="H4"; break;
      case 1440 : TimeFrameStr2="D1"; break;
      case 10080 : TimeFrameStr2="W1"; break;
      case 43200 : TimeFrameStr2="MN1"; break;
      default : TimeFrameStr2="Current";
   }
   
   switch(select_3rd_tf_to_show)
      {
      case 1 : TimeFrameStr3="M1"; break;
      case 5 : TimeFrameStr3="M5"; break;
      case 15 : TimeFrameStr3="M15"; break;
      case 30 : TimeFrameStr3="M30"; break;
      case 60 : TimeFrameStr3="H1"; break;
      case 240 : TimeFrameStr3="H4"; break;
      case 1440 : TimeFrameStr3="D1"; break;
      case 10080 : TimeFrameStr3="W1"; break;
      case 43200 : TimeFrameStr3="MN1"; break;
      default : TimeFrameStr3="Current";
      }
      
   OldBars=Bars-2;
   
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
{ 
   RemoveObjects("LWMASlope_");
   return(0);
}
//-------------------------------------------------------------------+
void RemoveObjects(string prefix)
//-------------------------------------------------------------------+
{   
   int i;
   string objname;

   for (i = ObjectsTotal(); i >= 0; i--) 
   {
      objname = ObjectName(i);
      if (StringFind(objname, prefix, 0) > -1) ObjectDelete(objname);
   }
} 

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   //check if a new bar, then, do a run
   if(OldBars==Bars) return(0);
   OldBars=Bars;//a new bar, run further down, reset this flag
   
   int counted_bars = IndicatorCounted();
   if ( counted_bars < 0 ) return(-1);
   if ( counted_bars > 0 ) counted_bars--;
               
   int Limit = MathMin( Bars - 1, Bars - counted_bars + LWMA_Period );
     
   double atr ; 
   double atrMTF;
   double atrMTF2;
   double atrMTF3;
     
   ArrayResize(vect, Limit +10); 
   ArrayResize(vect_sma, Limit +10); 
   
   int sma_period = MathMax(MathSqrt(LWMA_Period), 3); //smoothy period   
   
   for(int x = Limit; x >=0; x--) 
      vect[x] = 2*WMA(x, LWMA_Period/2) - WMA(x, LWMA_Period); //slope    

   for (x = Limit-sma_period-1; x >=0; x--)
      vect_sma[x] = findAvg_SMA(vect, sma_period, x);          //signal or smooth with sma
    
   //-- main loop
   for(x = Limit-sma_period-1; x >= 0; x--)
   {  
      //calculate ATR     
      atr = iATR(NULL,0, ATR_Period, x+10)*0.1;                //use  atr /10
            
      if (atr == 0) 
      {  Slope[x] = 0;  //error
         continue;   //return for next loop
      }
           
      Slope[x] = (vect_sma[x] - vect_sma[x+1] ) / atr;         //smoothy slope
      
      Up1[x] = 0.0;   
      Dn1[x] = 0.0;     
      Mid1[x]= 0.0;   
      Up2[x] = 0.0;   
      Dn2[x] = 0.0;     
      Mid2[x]= 0.0;   
   
      if ( Slope[x] > Bull_Above )
      {
         if(Slope[x] < Slope[x+1]) 
            Up1[x] = Slope[x];
         else 
            Up2[x] = Slope[x];//strong up trend
      }
      else 
      if ( Slope[x] < Bear_Below )
      {
         if(Slope[x] < Slope[x+1]) 
            Dn2[x] = Slope[x];//strong dn trend
         else 
            Dn1[x] = Slope[x];
      }
      else  
      {
         if(Slope[x] < Slope[x+1]) 
            Mid2[x] = Slope[x];//strong range
         else 
            Mid1[x] = Slope[x];
      } 
   
      //show slop[0]
      if(x==0)
      {
         string tt=DoubleToStr(Slope[x], 2);//slop value

         ObjectCreate ("LWMASlope_label",OBJ_LABEL,WindowFind("LWMASlope_jack1"),0,0);
         ObjectSet    ("LWMASlope_label",OBJPROP_XDISTANCE,H_Pos);
         ObjectSet    ("LWMASlope_label",OBJPROP_YDISTANCE,V_Pos);
         ObjectSet    ("LWMASlope_label",OBJPROP_CORNER,  Corner);
         ObjectSetText("LWMASlope_label",tt+"       ",Font_Size,"Arial",Font_Color);
   
         string sObjName1="LWMASlope_InfoBar1";
         ObjectCreate (sObjName1, OBJ_LABEL,WindowFind("LWMASlope_jack1"), 0, 0);
         ObjectSet    (sObjName1, OBJPROP_CORNER,    Corner_Text);
         ObjectSet    (sObjName1, OBJPROP_XDISTANCE, H_Pos_text);//left to right
         ObjectSet    (sObjName1, OBJPROP_YDISTANCE, V_Pos_text);//top to bottom

         if (Slope[x] > Bull_Above)
            ObjectSetText(sObjName1, "Buy Only ", Font_Size_text, "Verdana", YellowGreen);
         else 
         if (Slope[x] < Bear_Below)
            ObjectSetText(sObjName1, "Sell Only ", Font_Size_text, "Verdana", Red);
         else 
            ObjectSetText(sObjName1, "Ranging ", Font_Size_text, "Verdana", DarkGray);
      }//end if 
   }//end for, current time frame slope calculation done
   
      //------------------
      //other 3 time frame
      //------------------
      x =1; 
      atrMTF = iATR(NULL,select_1st_tf_to_show,  ATR_Period,x+10)*0.1;
      atrMTF2= iATR(NULL,select_2nd_tf_to_show,  ATR_Period,x+10)*0.1;
      atrMTF3= iATR(NULL,select_3rd_tf_to_show,  ATR_Period,x+10)*0.1;
      double hh=0;
      //calculate tma in 3 other MTF
      if(show_1st_MTF && atrMTF !=0)// && Period()<= select_1st_tf_to_show)
      {
         hh  = Slope_MTF(Symbol(), select_1st_tf_to_show, LWMA_Period, LWMA_Method, LWMA_Price);
         if (hh>= Bull_Above) Font_Color_MTF=Lime;
         else 
         if (hh<= Bear_Below) Font_Color_MTF=Red;
         else                 Font_Color_MTF=DarkGray;
         
         string jj=DoubleToStr(hh,2);
      
         ObjectCreate ("LWMASlope_label MTF",OBJ_LABEL,WindowFind("LWMASlope_jack1"),0,0);
         ObjectSet    ("LWMASlope_label MTF",OBJPROP_XDISTANCE,H_Pos_MTF);
         ObjectSet    ("LWMASlope_label MTF",OBJPROP_YDISTANCE,V_Pos_MTF);
         ObjectSet    ("LWMASlope_label MTF",OBJPROP_CORNER,   Corner_MTF);
         ObjectSetText("LWMASlope_label MTF",jj+"  "+TimeFrameStr+" ",Font_Size_MTF,"Arial",Font_Color_MTF);
      }
      else ObjectDelete("LWMASlope_label MTF");
   
      if(show_2nd_MTF && atrMTF2 !=0)// && Period()<= select_2nd_tf_to_show)
      {
         hh  = Slope_MTF(Symbol(), select_2nd_tf_to_show, LWMA_Period, LWMA_Method, LWMA_Price);
         if(hh>=Bull_Above) Font_Color_MTF_2nd=Lime;
         else 
         if(hh<=Bear_Below) Font_Color_MTF_2nd=Red;
         else               Font_Color_MTF_2nd=DarkGray;
         jj=DoubleToStr(hh,2);
         ObjectCreate("LWMASlope_label MTF_2nd",OBJ_LABEL,WindowFind("LWMASlope_jack1"),0,0);
         ObjectSet("LWMASlope_label MTF_2nd",OBJPROP_XDISTANCE,H_Pos_MTF_2nd);
         ObjectSet("LWMASlope_label MTF_2nd",OBJPROP_YDISTANCE,V_Pos_MTF_2nd);
         ObjectSet("LWMASlope_label MTF_2nd",OBJPROP_CORNER,Corner_MTF_2nd);
         ObjectSetText("LWMASlope_label MTF_2nd",jj+"  "+TimeFrameStr2+" ",Font_Size_MTF_2nd,"Arial",Font_Color_MTF_2nd);
      }
      else ObjectDelete("LWMASlope_label MTF_2nd");
   
      if(show_3rd_MTF && atrMTF3 !=0)// && Period()<= select_3rd_tf_to_show)
      {
         hh  = Slope_MTF(Symbol(), select_3rd_tf_to_show, LWMA_Period, LWMA_Method, LWMA_Price);
         if(hh>=Bull_Above) Font_Color_MTF_3rd=YellowGreen;
         else 
         if(hh<=Bear_Below) Font_Color_MTF_3rd=Red;
         else               Font_Color_MTF_3rd=DarkGray;
         jj=DoubleToStr(hh,2);
         ObjectCreate("LWMASlope_label MTF_3rd",OBJ_LABEL,WindowFind("LWMASlope_jack1"),0,0);
         ObjectSet("LWMASlope_label MTF_3rd",OBJPROP_XDISTANCE,H_Pos_MTF_3rd);
         ObjectSet("LWMASlope_label MTF_3rd",OBJPROP_YDISTANCE,V_Pos_MTF_3rd);
         ObjectSet("LWMASlope_label MTF_3rd",OBJPROP_CORNER,Corner_MTF_3rd);
         ObjectSetText("LWMASlope_label MTF_3rd",jj+"  "+TimeFrameStr3+" ",Font_Size_MTF_3rd,"Arial",Font_Color_MTF_3rd);
      }
      else ObjectDelete("LWMASlope_label MTF_3rd");
   
   //done
   return(0);
}

//+------------------------------------------------------------------+ 
//| slope                                                            | 
//+------------------------------------------------------------------+ 
double Slope_MTF(string pair_, int tf_, int ma_period_, int ma_method_, int ma_price_ )
{  
   double vect_[300],vect_sma_[300];
   int Limit =300;
  
   int sma_period = MathMax(MathSqrt(ma_period_), 3); //smoothy period   
   
   for(int x = Limit; x >=0; x--) 
      vect_[x] = 2*WMA_MTF(pair_,tf_,ma_period_ /2,ma_method_,ma_price_, x) - WMA_MTF(pair_,tf_,ma_period_,ma_method_,ma_price_, x);   

   for (x = Limit-ma_period_-1; x >=0; x--)
      vect_sma_[x] = findAvg_SMA(vect_, sma_period, x);
     
   //calculate ATR     
   double atr = iATR(pair_,tf_, ATR_Period, 11)*0.1;
            
   if(atr == 0) return(0); //error
      
   return( (vect_sma_[1] - vect_sma_[2]) / atr );
} 

//+------------------------------------------------------------------+ 
//| WMA                                                              | 
//+------------------------------------------------------------------+ 
double WMA(int x, int p) 
{ 
    return(iMA(NULL, 0, p, 0, LWMA_Method, LWMA_Price, x));    
} 

double WMA_MTF(string pair_, int tf_, int p_, int ma_method_, int ma_price_,  int x) 
{ 
    return(iMA(pair_, tf_, p_, 0, ma_method_, ma_price_, x));    
} 

//+------------------------------------------------------------------+
//|  findAvg_SMA as signal                                           |
//+------------------------------------------------------------------+  
double findAvg_SMA(double& y[], int period_, int shift) 
{  double sum = 0;
   for(int k = shift; k < (shift + period_); k++ ) 
   {     
       sum += y[k];
   }
   sum = sum / period_;
   return(sum);
}  
//+------------------------------------------------------------------+
/*
//+------------------------------------------------------------------+
//| calcTma()                                                        |
//+------------------------------------------------------------------+
double calcTma( int x )
{
   double Sum  = (LWMA_Period+1)*Close[x];
   double Sumw = (LWMA_Period+1);
   int jnx, knx;
         
   for ( jnx = 1, knx = LWMA_Period; jnx <= LWMA_Period; jnx++, knx-- )
   {
      Sum  += ( knx * Close[x+jnx] );
      Sumw += knx;

      if ( jnx <= x )
      {
         Sum  += ( knx * Close[x-jnx] );
         Sumw += knx;
      }
   }
   return( Sum / Sumw );
}
 
 
double calcTmaMTF( int x , int tf)
{
   double Sum  = (LWMA_Period+1)*iClose(Symbol(),tf,x);
   double Sumw = (LWMA_Period+1);
   int jnx, knx;
         
   for ( jnx = 1, knx = LWMA_Period; jnx <= LWMA_Period; jnx++, knx-- )
   {
      Sum  += ( knx * iClose(Symbol(),tf,x+jnx) );
      Sumw += knx;

      if ( jnx <= x )
      {
         Sum  += ( knx * iClose(Symbol(),tf,x-jnx) );
         Sumw += knx;
      }
   }
   return( Sum / Sumw );
}
*/
 
 
 
 
 
 
 
 
 
 
 
 
 
 



   


